
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class StreamsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const streams = await db.streams.create(
            {
                id: data.id || undefined,
        
        name_om: data.name_om
        ||
        null
            ,
            
        name_am: data.name_am
        ||
        null
            ,
            
        name_en: data.name_en
        ||
        null
            ,
            
        stream_type: data.stream_type
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return streams;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const streamsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name_om: item.name_om
            ||
            null
            ,
            
                name_am: item.name_am
            ||
            null
            ,
            
                name_en: item.name_en
            ||
            null
            ,
            
                stream_type: item.stream_type
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const streams = await db.streams.bulkCreate(streamsData, { transaction });

        // For each item created, replace relation files
        

        return streams;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const streams = await db.streams.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name_om !== undefined) updatePayload.name_om = data.name_om;
        
        
        if (data.name_am !== undefined) updatePayload.name_am = data.name_am;
        
        
        if (data.name_en !== undefined) updatePayload.name_en = data.name_en;
        
        
        if (data.stream_type !== undefined) updatePayload.stream_type = data.stream_type;
        
        
        updatePayload.updatedById = currentUser.id;

        await streams.update(updatePayload, {transaction});

        
        

        
        

        

        return streams;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const streams = await db.streams.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of streams) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of streams) {
                await record.destroy({transaction});
            }
        });


        return streams;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const streams = await db.streams.findByPk(id, options);

        await streams.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await streams.destroy({
            transaction
        });

        return streams;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const streams = await db.streams.findOne(
            { where },
            { transaction },
        );

        if (!streams) {
            return streams;
        }

        const output = streams.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.subject_offerings_stream = await streams.getSubject_offerings_stream({
            transaction
        });
        
        
        
        output.students_current_stream = await streams.getStudents_current_stream({
            transaction
        });
        
        
        output.class_sections_stream = await streams.getClass_sections_stream({
            transaction
        });
        
        
        
        
        
        
        
        
        output.study_materials_stream = await streams.getStudy_materials_stream({
            transaction
        });
        
        
        output.exams_stream = await streams.getExams_stream({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        output.admission_applications_requested_stream = await streams.getAdmission_applications_requested_stream({
            transaction
        });
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name_om) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'streams',
                        'name_om',
                        filter.name_om,
                    ),
                };
            }
            
            if (filter.name_am) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'streams',
                        'name_am',
                        filter.name_am,
                    ),
                };
            }
            
            if (filter.name_en) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'streams',
                        'name_en',
                        filter.name_en,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.stream_type) {
                where = {
                    ...where,
                stream_type: filter.stream_type,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.streams.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'streams',
                        'name_en',
                        query,
                    ),
                ],
            };
        }

        const records = await db.streams.findAll({
            attributes: [ 'id', 'name_en' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name_en', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name_en,
        }));
    }

    
};

